package dev.shadowsoffire.apotheosis.adventure.socket.gem.bonus.special;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.google.common.base.Preconditions;
import com.mojang.datafixers.kinds.App;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.datafixers.util.Function6;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import dev.shadowsoffire.apotheosis.Apotheosis;
import dev.shadowsoffire.apotheosis.adventure.affix.Affix;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.GemClass;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.bonus.GemBonus;
import dev.shadowsoffire.placebo.codec.IngredientCodec;
import dev.shadowsoffire.placebo.codec.PlaceboCodecs;
import dev.shadowsoffire.placebo.json.ItemAdapter;
import dev.shadowsoffire.placebo.util.StepFunction;
import it.unimi.dsi.fastutil.objects.ObjectArrayList;
import java.util.Map;
import java.util.Optional;
import net.minecraft.ChatFormatting;
import net.minecraft.core.registries.Registries;
import net.minecraft.network.chat.Component;
import net.minecraft.tags.TagKey;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.storage.loot.LootContext;
import net.minecraft.world.level.storage.loot.parameters.LootContextParams;

public class DropTransformBonus extends GemBonus {
  public static Codec<dev.shadowsoffire.apotheosis.adventure.socket.gem.bonus.special.DropTransformBonus> CODEC;
  
  protected final Optional<TagKey<Block>> tag;
  
  protected final Ingredient inputs;
  
  protected final ItemStack output;
  
  protected final Map<LootRarity, StepFunction> values;
  
  protected final String descKey;
  
  static {
    CODEC = RecordCodecBuilder.create(inst -> inst.group(gemClass(), (App)PlaceboCodecs.nullableField(TagKey.m_203877_(Registries.f_256747_), "blocks").forGetter(()), (App)IngredientCodec.INSTANCE.fieldOf("inputs").forGetter(()), (App)ItemAdapter.CODEC.fieldOf("output").forGetter(()), (App)VALUES_CODEC.fieldOf("values").forGetter(()), (App)Codec.STRING.fieldOf("desc").forGetter(())).apply((Applicative)inst, dev.shadowsoffire.apotheosis.adventure.socket.gem.bonus.special.DropTransformBonus::new));
  }
  
  public DropTransformBonus(GemClass gemClass, Optional<TagKey<Block>> tag, Ingredient inputs, ItemStack output, Map<LootRarity, StepFunction> values, String descKey) {
    super(Apotheosis.loc("drop_transform"), gemClass);
    this.tag = tag;
    this.inputs = inputs;
    this.output = output;
    this.values = values;
    this.descKey = descKey;
  }
  
  public Codec<? extends GemBonus> getCodec() {
    return (Codec)CODEC;
  }
  
  public Component getSocketBonusTooltip(ItemStack gem, LootRarity rarity) {
    float chance = ((StepFunction)this.values.get(rarity)).min();
    return (Component)Component.m_237110_(this.descKey, new Object[] { Affix.fmt(chance * 100.0F) }).m_130940_(ChatFormatting.YELLOW);
  }
  
  public void modifyLoot(ItemStack gem, LootRarity rarity, ObjectArrayList<ItemStack> loot, LootContext ctx) {
    if (ctx.m_78936_(LootContextParams.f_81461_)) {
      BlockState state = (BlockState)ctx.m_165124_(LootContextParams.f_81461_);
      if (this.tag.isPresent() && !state.m_204336_(this.tag.get()))
        return; 
      if (ctx.m_230907_().m_188501_() <= ((StepFunction)this.values.get(rarity)).min())
        for (int i = 0; i < loot.size(); i++) {
          ItemStack stack = (ItemStack)loot.get(i);
          if (this.inputs.test(stack)) {
            ItemStack outCopy = this.output.m_41777_();
            outCopy.m_41764_(stack.m_41613_());
            loot.set(i, outCopy);
          } 
        }  
    } 
  }
  
  public dev.shadowsoffire.apotheosis.adventure.socket.gem.bonus.special.DropTransformBonus validate() {
    Preconditions.checkNotNull(this.values);
    this.values.forEach((k, v) -> {
          Preconditions.checkNotNull(k);
          Preconditions.checkNotNull(v);
        });
    return this;
  }
  
  public boolean supports(LootRarity rarity) {
    return this.values.containsKey(rarity);
  }
  
  public int getNumberOfUUIDs() {
    return 0;
  }
}
